
import java.lang.Math;

/**
 * cartesian vector
 * as this is a kind of structure, the attributes are public
 *
 * @author Matthias Lang
 * @version $Id: CVector.java,v 1.1 2002/07/10 00:37:01 Lang Exp $
 **/
public class CVector
{
    double x,y;

    /**
     * creates a new cartesian vector, initializing x and y to zero
     **/
    public CVector()
    {
	x = 0.;
	y = 0.;
    }

     /**
     * creates a new cartesian vector, initializing x and y to the given values
     *
     * @param x initial value for x
     * @param y initial value for y
     **/
    public CVector( double x, double y )
    {
	this.x = x;
	this.y = y;
    }

    /**
     * calculates the sum of two vectors
     *
     * @param other the second addend
     * @return the sum
     **/
    public CVector add( CVector other )
    {
	return new CVector( x+other.x, y+other.y );
    }

    /**
     * calculates this vector minus the other
     *
     * @param other subtrahend
     * @return the difference
     **/
    public CVector sub( CVector other )
    {
	return new CVector( x-other.x, y-other.y );
    }

    /**
     * returns the length of the vector
     *
     * @return the length of the vector
     **/
    public double length()
    {
	return Math.sqrt(x*x + y*y);
    }

}
