/**
 * A structure for storing a flag's data
 *
 * @author Matthias Lang
 * @version $Id: Flag.java,v 1.1 2002/07/10 00:37:01 Lang Exp $
 **/
public class Flag
{
    public CVector absPos;
    public PVector relPos;

    /**
     * creates a new flag object and finds out the flag's absolute position
     *
     * @param data 7 Strings, containing: name (e.g. "f r t"), rel. distance, rel. direction...
     **/
    public Flag(String[] data, int playDir)
    {
	absPos  = new CVector();
	switch (data[0].charAt(2))
	{
	    case 'c':
		absPos.x = 0.;
		if (data[0].length() == 3) break;
		if (data[0].charAt(4) == 't') absPos.y = -34.;
		else absPos.y = 34.;
		break;
	    case 'l':
		absPos.x = -57.5;
		if (data[0].length() == 5) // i.e. not one of (f l b|t 10..30)
		{
		    if (data[0].charAt(4) == '0') break; // y is already zero
		    absPos.x = -52.5;
		    if (data[0].charAt(4) == 't') absPos.y = -34.;
		    else absPos.y = 34.;
		}
		else 
		{
		    absPos.y = (data[0].charAt(6)-48)*10;
		    if (data[0].charAt(4) == 't') absPos.y *= -1.;
		}
		break;
	    case 'r': // same proceeding as above
		absPos.x = 57.5;
		if (data[0].length() == 5)
		{
		    if (data[0].charAt(4) == '0') break; //y is already zero
		    absPos.x = -52.5;
		    if (data[0].charAt(4) == 't') absPos.y = -34.;
		    else absPos.y = 34.;
		}
		else 
		{
		    absPos.y = (data[0].charAt(6)-48)*10;
		    if (data[0].charAt(4) == 't') absPos.y *= -1.;
		}
		break;
	    case 't':
		absPos.y = -39.;
		if (data[0].length() > 5)
		{
		    absPos.x = (data[0].charAt(6)-48)*10;
		    if (data[0].charAt(4) == 'l') absPos.x *= -1.;
		}
		break;
	    case 'b':
		absPos.y = 39.;
		if (data[0].length() > 5)
		{
		    absPos.x = (data[0].charAt(6)-48)*10;
		    if (data[0].charAt(4) == 'l') absPos.x *= -1.;
		}
		break;
	    case 'g':
		if (data[0].charAt(4) == 'l') absPos.x = -52.5;
		else absPos.x = 52.5;
		if (data[0].charAt(6) == 't') absPos.y = -7.01;
		else absPos.y = 7.01;
		break;
	    case 'p':
		if (data[0].charAt(4) == 'l') absPos.x = -36.;
		else absPos.x = 36.;
		if (data[0].charAt(6) == 't') absPos.y = -20.175;
		if (data[0].charAt(6) == 'b') absPos.y = 20.175;
		break;
	    
	} // switch

	absPos.x *= playDir; // adapt coordinates to play direction
	absPos.y *= playDir;
	relPos = new PVector( Double.parseDouble( data[1] ), Integer.parseInt( data[2] ) );
    } // Constructor

} //class
