/**
 * Main class of our client.
 *
 * @author Matthias Lang
 * @version $Id: Robocupteam.java,v 1.1 2002/07/10 00:37:01 Lang Exp $
 */

public class Robocupteam
{
    /**
     * Starts the client
     *
     * @param args The arguments passed must specify <code>TEAMNAME SERVERNAME PORT visualize</code> in this order.
     */
    public static void main (String[] args) {
	String servername="", teamname="";
	int port=0;
	boolean visualization = false;
	try {
	    switch (args.length)
		{
		case 2:
		    if (args[1].equals("-v")) visualization = true;
		    else System.out.println("ignoring unknown option "+args[1]);
		case 1:
		    teamname = args[0];
		    servername = "localhost";
		    port = 6000;
		    break;
		case 3:
		    teamname = args[0];
		    servername = args[1];
		    port = Integer.parseInt(args[2]);
		    break;
		case 4:
		    teamname = args[0];
		    servername = args[1];
		    port = Integer.parseInt(args[2]);
		    if (args[3].equals("-v")) visualization = true;
		    else System.out.println("Ignoring unknown option "+args[3]);
		    break;

		case 0:
		    throw new NumberFormatException();
		default:
		    teamname = args[0];
		    servername = args[1];
		    port = Integer.parseInt(args[2]);
		    if (args[3].equals("-v")) visualization = true;
		    System.out.println("Usage: java Robocupteam TEAMNAME [SERVERNAME PORT] [-v]\nIgnoring additional arguments");
		    break;
		}
	} catch (NumberFormatException nfe) {
            System.out.println("Usage: java Robocupteam TEAMNAME [SERVERNAME PORT] [-v]");
            System.exit(1);
        }

	Player[] players = new Player[11];
	for ( int i = 0; i<11; i++ ) {
	    players[i] = new Player(servername, port, teamname, i+1);
	    players[i].start();
	    try {
		Thread.sleep(1000);
	    } catch (InterruptedException e) {
	    }
	}

	if (visualization) {
	    Worldmodell[] team = new Worldmodell[11];
	    for (int i = 0; i<11; i++ )
		team[i] = players[i].getData();

	    Runnable Weltbild = new WBV(team);
	    (new Thread(Weltbild)).start();
	}
  
    }
}
