/**
 * StrategyForward class which calculates positions and decides what to do next
 * methods in which forward and defender take different decisions
 *
 * @author Andrea Barth
 * @author Matthias Lang
 * @version $Id: StrategyForward.java,v 1.4 2002/07/15 01:18:43 Lang Exp $
 **/




public class StrategyForward extends Strategy
{
   
/**
 * the constructor initalizes a StrategyForward object
 **/
    public StrategyForward( CommunicationChannel com, Worldmodell data)
    {
	super(com, data);
    }


/**
 * decides if the player runs towards the ball
 *
 * @return true if the player should run to the ball, else false
 **/
    protected boolean decisionRunToBall()
    {
	// we are next to ball and ball is inside field
	if(!data.otherPlayerNext2Ball() && absBallPosition.x < 53.5 )
	    return true;
	else
	    return false;
    }
	

/**
 * decides where and how to kick and executes the kick
 *
 * @author Annika Niehage
 **/
    protected void calcKick()
    {
	PVector goalDist = new PVector(GOALPOSITION.length(),calcAngleToPos(GOALPOSITION));

	// shot on goal
	if(ownPosition.x >= 30.) {
	    if (data.getPlayMode()==11) action.kick( 100., calcAngleToPos( new CVector( 41.5, 0 )));
	    else  action.kick( 100., goalDist.direction );
	}

	else // dribbel to goal
	{
	    action.kick( 17., goalDist.direction );
	}

    }

    /**
     * adjust player's position inside assigned area
     **/
    protected void adjustPosition()
    {
	CVector target;
	if (absBallPosition.x<10)
	    target = standPosition.sub( new CVector(10., 0.));
	else if (data.getPlayMode()==11)
	    target = standPosition.add( new CVector(35., 0.));
	else target = standPosition;

	if (Math.abs(ownPosition.sub(target).length())<3)
	    turnToBall();
	else 
	    calcDashPowerAndTurn(target);

    }



/**
 * gives his standard and start position to each player
 *
 **/
    protected void  calcStandPosition()
    {
	if(playerNum == 9 || playerNum == 1)
	{
	    standPosition = new CVector(15, -20);
	    startPosition = new CVector(-5, -20); 
	}

	if(playerNum == 10)
	{    
	    standPosition = new CVector(15, 0);
	    startPosition = new CVector(-10, 1);
	}

	if(playerNum == 11)
	{    
	    standPosition = new CVector(15, 20);
	    startPosition = new CVector(-5, 20);
	}

    }

}//class










