/**
 * to test one Player:
 * java TestPlayer localhost 6000 TEAMNAME PLAYERTYPE
 *
 * @author Matthias Lang
 * @version 1.2
 */
public class TestPlayer
{
    public static void main(String[] args)
    {
	TPlayer player = new TPlayer(args[0], Integer.parseInt(args[1]), args[2],Integer.parseInt(args[3]));
	player.mach();

    }


}


class TPlayer
{

    private CommunicationChannel communication;
    private Worldmodell data;
    private DivideString messageHandler;
    private Strategy strategy;

    /**
     * Creates a new <code>Player</code> instance.
     *
     * @param servername a <code>String</code> value specifying the the name of the server
     * @param serverport an <code>int</code> value specifying the port on which the server
     *                   listens for incoming packets
     * @param teamName a <code>String</code> value is the name of the team you want to join/create
     */
    public TPlayer( String servername, int serverport, String teamName, int playerType )
    {
        communication = new CommunicationChannel(servername, serverport);

	data = new Worldmodell();
	

 	if (playerType == 1)
 	{
 	    communication.send(new String("(init "+teamName+" (version 7.0) (goalie)"));
 	    strategy = new StrategyKeeper(communication,data);
 	}
 	else
 	{
  	    communication.send(new String("(init "+teamName+" (version 7.0))"));
  	    if (playerType == 2) 
  		strategy = new StrategyDefender(communication,data);
  	    if (playerType == 3) 
		strategy = new StrategyForward(communication,data);
  	}
	messageHandler = new DivideString( teamName, data, strategy );

    
	
// 	Worldmodell[] team = new Worldmodell[11];
// 	team[0] = data;
	
// 	Runnable Weltbild = new WBV(team);
// 	(new Thread(Weltbild)).start();
    }


    /**
     * This method had to be overwritten from <code>Thread</code>. It is
     * executed when <code>start()</code> is called for the <code>Player</code>
     * Thread
     *
     */
    public void mach()
    {
	while(true)
	{
	    mainLoop();
	}

    }

    /**
     * main loop which is executed from run
     *
     **/
    private void mainLoop()
    {
	messageHandler.runDivideString( communication.receive() );
    }


}
