/**
 * This class can save the error messages. Is written to get the error Content from the DivideString class, but
 * can be used by some other classes!
 *
 * I suggest that the error file should be named like writeErrorMsg.ClassItOccurse.java .
 *
 * @author Tim Oliver Wagner
 * @version $Id: WriteErrorMsg.java,v 1.2 2002/07/12 17:54:56 Niehage Exp $
 **/


import java.io.*;

abstract public class WriteErrorMsg {

    static String outputFile;
    static String[] content;

    /**
     * Have to be called if some error occures.
     *
     * @param input some input what should be written to the File
     * @param errMsg some Error Message which should be written to the File
     * @param oFile specifies the Filename in this should be written the Error Message. I suggest 
     *              that the error file should be named like writeErrorMsg.ClassItOccurse.java .
     **/
    public static void writeErrMsg (String input, Exception errorMsg, String oFile) {
	outputFile = oFile.substring(0, oFile.length());
	if (existFile())
	    readFile();
	String errMsg = errorMsg.getMessage();
	writeTheErrorFile(input, errMsg);
    }

    /**
     * Read the current content from the file
     **/
    private static void readFile () {
	BufferedReader br;
	String currentRead;
	int countLines = 0;
	try {
	    br = new BufferedReader(new InputStreamReader(new FileInputStream(outputFile)));
	    currentRead = br.readLine();
	    while (currentRead != null) {
		currentRead = br.readLine();
		++countLines;
	    }
	    br.close();
	    content = new String[countLines];

	    br = new BufferedReader(new InputStreamReader(new FileInputStream(outputFile)));
	    for (int i = 0; i<content.length; ++i)
		content[i] = br.readLine();
	    br.close();
	}
	catch (FileNotFoundException fnfe) {
	    System.err.println("Could not open file for reading. Maybe file doesn't exists at the moment.");
	}
	catch (IOException ioe) {
	    System.err.println("Could not read a line of the file or can't close the BufferedReader.");
	    System.exit(1);
	}
    }

    /**
     * Write the new content to the file (if there are some String lines in content[] then it will be written in 
     * top of the new messages.)
     *
     * @param input some input what should be written to the File
     * @param errMsg some Error Message which should be written to the File
     **/
    private static void writeTheErrorFile (String input, String errMsg) {
	PrintWriter pw;
	try {
	pw = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
	if (content != null)
	    for (int i=0; i < content.length; ++i)
		pw.println(content[i]);
	pw.println("!!!!!!!!!!!!!!Here starts a new error message!!!!!!!!!!!!!!!!");
	pw.println(input);
	pw.println(errMsg);
	pw.close();
	}
	catch (IOException ioe) {
	    System.err.println("IOException occurs in File WriteErrorMsg!");
	    System.err.println (ioe);
	    System.exit(1);
	}
    }

    /**
     * If the File exists, then return true else return false
     **/
    private static boolean existFile () {
	try {
	    BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(outputFile)));
	    br.close();
	    return true;
	}
	catch (FileNotFoundException fnfe) {
	    return false;
	}
	catch (IOException ioe) {
	    System.err.println("Can't close the File!");
	}
	return false;
    }
}
